<?php
class ControllerExtensionModuleRouteeOrders extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/orders');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title', 'text_process', 'text_success', 'text_error', 'text_not_imported', 'button_insert', 'button_insert_mass', 'text_all_imported', 'text_not_exists' );
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }
		
		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/orders', 'token=' . $this->session->data['token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		if( 1 == $this->config->get('module_routee_order_exported') ) {
			$data['order_exists'] = 0;
		} else {
			$data['order_exists'] = 1;
		}
		
		$data['token'] = $this->session->data['token'];
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/orders/insert_mass', 'token=' . $this->session->data['token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/orders/insert_mass', 'token=' . $this->session->data['token'], true));
		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/orders', $data));
	}
	
	public function insert_mass() {
        $action = $_POST['action'];
        $token  = $_GET['token'];
        $uuid = $this->config->get('module_routee_uuid');
        $this->load->language('extension/module/routee/orders');
        $reload = 0;
        if ( $this->session->data['token'] != $token || empty($uuid)) {
            $this->session->data['error_warning'] = $this->language->get('text_auth_error');
            $result = array(
                'reload' => 1
            );
        } else {
            $limit = 100;
            $this->load->model('sale/order');

            $filter_data = array(
                'sort'    			=> 'o.order_id',
                'order'   			=> 'DESC',
            );
            if ($action == "get_count") {
                $orderData = $this->model_sale_order->getOrders($filter_data);
                $t_count = count($orderData);
                if ($t_count == 0){
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $result = array(
                        'reload' => 1
                    );
                } else {
                    $result = array(
                        'reload' => $reload,
                        'count' => $t_count
                    );
                }

            } elseif ( $action == "export_data" ) {
                unset($this->session->data['error_warning'] , $this->session->data['success']);
                $cycle = $_POST['cycle_count'];
                $filter_data['limit'] = $limit;
                $filter_data['start'] = ($cycle - 1) * 100;
                $orderInfo = [];
                $orderData = $this->model_sale_order->getOrders($filter_data);
                $c_count = count($orderData);

                foreach($orderData as $k => $orderRow) {
                    $order = array();

                    $order_info = $this->model_sale_order->getOrder($orderRow['order_id']);
                    if($order_info) {
                        $order['order_details'] = array('customer_id' => $order_info['customer_id'], 'order_id' => $order_info['order_id'], 'order_status' => $order_info['order_status'], 'shipping_method' => $order_info['shipping_method'], 'payment_method' => $order_info['payment_method'], 'total_price' => $order_info['total']);
                    }

                    $order_products = array();
                    $products = $this->model_sale_order->getOrderProducts($orderRow['order_id']);

                    foreach ($products as $product) {
                        $order_products[] = array(
                            'product_id' => $product['product_id'],
                            'quantity'   => $product['quantity'],
                        );
                    }

                    $order['order_products'] = $order_products;

                    $orderInfo[] = $order;
                }
                $resultJson = $this->send_data($uuid, $orderInfo);
                if (!isset($resultJson)){
                    $this->session->data['error_warning'] = $this->language->get('text_error');
                    $reload = 1;
                } elseif (!empty($resultJson['message'])){
                    if ($c_count < 100){
                        $this->load->model('setting/setting');
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_order_exported', 1 );
                        $this->session->data['success'] = $this->language->get('text_success');
                        $reload = 1;
                    }
                }
                $result = array(
                    'c_count' => $c_count,
                    'reload' => $reload
                );
            }
        }
        echo json_encode($result);
        exit;
	}

    public function send_data($uuid, $ordersInfo) {
        $data["uuid"] = $uuid;
        $data['data'][0] = array(
            'name' => 'Orders',
            'description' => 'Shop Orders',
            'object' => $ordersInfo,
        );
        $postData = json_encode($data);
        $ch = curl_init('https://idata.routee.net/api/data');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);

        $this->load->library('routee');
        $this->routee->write("Mass Orders: ".json_encode($data)." Result: ".$result);

        return json_decode($result, 1);
    }
}
