<?php
class ControllerExtensionModuleRouteeProducts extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/routee/products');

		$this->document->setTitle($this->language->get('heading_title'));

        $texts = array( 'heading_title', 'text_process', 'text_success', 'text_error', 'text_not_imported', 'button_insert', 'button_insert_mass', 'text_all_imported', 'text_not_exists' );
        foreach ($texts as $text) {
            $data[$text] = $this->language->get($text);
        }

		// Send Data to Routee
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/routee/products', 'token=' . $this->session->data['token'], true)
		);

		if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}
		
		if (isset($this->session->data['error_warning'])) {
			$data['error_warning'] = $this->session->data['error_warning'];

			unset($this->session->data['error_warning']);
		} else {
			$data['error_warning'] = '';
		}
		if( 1 == $this->config->get('module_routee_product_exported') ) {
			$data['product_exists'] = 0;
		} else {
			$data['product_exists'] = 1;
		}
		
		$data['token'] = $this->session->data['token'];
		
		$data['insert_mass'] = $this->url->link('extension/module/routee/products/insert_mass', 'token=' . $this->session->data['token'], true);
		
		$data['insert_mass_import'] = str_replace('&amp;', '&', $this->url->link('extension/module/routee/products/insert_mass', 'token=' . $this->session->data['token'], true));

		
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/routee/products', $data));
	}

    public function insert_mass() {
        $action = $_POST['action'];
        $token  = $_GET['token'];
        $uuid = $this->config->get('module_routee_uuid');
        $this->load->language('extension/module/routee/products');
        $reload = 0;
        if ( $this->session->data['token'] != $token || empty($uuid)) {
            $this->session->data['error_warning'] = $this->language->get('text_auth_error');
            $result = array(
                'reload' => 1
            );
        } else {
            $limit = 100;
            $this->load->model('catalog/product');
            $this->load->model('catalog/category');

            $filter_data = array(
                'sort'    			=> 'pd.name',
                'order'   			=> 'ASC'
            );
            if ($action == "get_count") {
                $productData = $this->model_catalog_product->getProducts($filter_data);
                $t_count = count($productData);
                if ($t_count == 0){
                    $this->session->data['error_warning'] = $this->language->get('text_not_exists');
                    $result = array(
                        'reload' => 1
                    );
                } else {
                    $result = array(
                        'reload' => $reload,
                        'count' => $t_count
                    );
                }

            } elseif ( $action == "export_data" ) {
                unset($this->session->data['error_warning'] , $this->session->data['success']);
                $cycle = $_POST['cycle_count'];
                $filter_data['limit'] = $limit;
                $filter_data['start'] = ($cycle - 1) * 100;
                $productInfo = [];
                $productData = $this->model_catalog_product->getProducts($filter_data);
                $c_count = count($productData);

                foreach($productData as $k => $productRow) {
                    $searchProduct = array();
                    $special = false;
                    $product_specials = $this->model_catalog_product->getProductSpecials($productRow['product_id']);

                    foreach ($product_specials  as $product_special) {
                        if (($product_special['date_start'] == '0000-00-00' || strtotime($product_special['date_start']) < time()) && ($product_special['date_end'] == '0000-00-00' || strtotime($product_special['date_end']) > time())) {
                            $special = $product_special['price'];
                            break;
                        }
                    }

                    $category = array();

                    $categories = $this->model_catalog_product->getProductCategories($productRow['product_id']);

                    foreach ($categories as $category_id) {
                        $category_info = $this->model_catalog_category->getCategory($category_id);

                        if ($category_info) {
                            $category[] = $category_info['name'];
                        }
                    }

                    $image_link = $product_link = "";

                    if (isset($productRow['image'])) {
                        $image_link = HTTP_CATALOG.$productRow['image'];
                    }

                    $product_link = HTTP_CATALOG.'index.php?route=product/product&product_id='.$productRow['product_id'];

                    $discount = array();

                    $product_discounts = $this->model_catalog_product->getProductDiscounts($productRow['product_id']);

                    foreach ($product_discounts as $product_discount) {
                        $discount[] = array(
                            'price'             => $this->tax->calculate($product_discount['price'], $productRow['tax_class_id'], $this->config->get('config_tax')),
                            'quantity'          => $product_discount['quantity'],
                            'date_start'        => ($product_discount['date_start'] != '0000-00-00') ? $product_discount['date_start'] : '',
                            'date_end'          => ($product_discount['date_end'] != '0000-00-00') ? $product_discount['date_end'] : ''
                        );
                    }

                    $product_description = $this->model_catalog_product->getProductDescriptions($productRow['product_id']);

                    if($special) {
                        $price = $special;
                    } else {
                        $price = $productRow['price'];
                    }

                    foreach ($product_description as $language_id => $value) {
                        $searchProduct = array(
                            'product_id' => $productRow['product_id'],
                            'name' => $value['name'],
                            'description' => html_entity_decode($value['description'], ENT_QUOTES, 'UTF-8'),
                            'categories' => $category,
                            'stock_quantity' => $productRow['quantity'],
                            'price' => $this->tax->calculate($price, $productRow['tax_class_id'], $this->config->get('config_tax')),
                            'discount' => $discount,
                            'image_link' => $image_link,
                            'product_link' => $product_link
                        );
                    }
                    $productInfo[] = $searchProduct;
                }
                $resultJson = $this->send_data($uuid, $productInfo);
                if (!isset($resultJson)){
                    $this->session->data['error_warning'] = $this->language->get('text_error');
                    $reload = 1;
                } elseif (!empty($resultJson['message'])){
                    if ($c_count < 100){
                        $this->load->model('setting/setting');
                        $this->model_setting_setting->editSettingValue('module_routee', 'module_routee_product_exported', 1 );
                        $this->session->data['success'] = $this->language->get('text_success');
                        $reload = 1;
                    }
                }
                $result = array(
                    'c_count' => $c_count,
                    'reload' => $reload
                );
            }

        }
        echo json_encode($result);
        exit;
    }

    public function send_data($uuid, $productInfo) {

        $data["uuid"] = $uuid;
        $data['data'][0] = array(
            'name' => 'Products',
            'description' => 'Shop Products',
            'object' => $productInfo,
        );
        $postData = json_encode($data);
        $ch = curl_init('https://idata.routee.net/api/data');
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
        curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $result = curl_exec($ch);

        $this->load->library('routee');
        $this->routee->write("Mass Products: ".json_encode($data)." Result: ".$result);

        return json_decode($result, 1);
    }
}
